// jPaginate Plugin for jQuery
// by Angel Grablev for Enavu Web Development network (enavu.com)
// Dual license under MIT and GPL :) enjoy
/*

To use simply call .paginate() on the element you wish like so:
$("#content").jPaginate(); 

you can specify the following options:
items = number of items to have per page on pagination
next = the text you want to have inside the text button
previous = the text you want in the previous button
active = the class you want the active paginaiton link to have
pagination_class = the class of the pagination element that is being generated for you to style
minimize = minimizing will limit the overall number of elements in the pagination links
nav_items = when minimize is set to true you can specify how many items to show
cookies = if you want to use cookies to remember which page the user is on, true by default

*/

(function(jQuery){
    jQuery.fn.jPaginate = function(options) {
        var defaults = {
            items: 4,
			number_of_items: 11,
			intCurrentPage : 1,
            next: ">>",
            previous: "<<",
            active: "active",
            pagination_class: "pagination",
            minimize: false,
            nav_items: 6,
			cookies: true
        };
        var options = jQuery.extend(defaults, options);

        return this.each(function() {
            // object is the selected pagination element list
            obj = jQuery(this);
            // this is how you call the option passed in by plugin of items
            var show_per_page = options.items;
            //getting the amount of elements inside parent element
            //var number_of_items = obj.children().size();
			var number_of_items = options.number_of_items;
            //calculate the number of pages we are going to have
            var number_of_pages = Math.ceil(number_of_items/show_per_page);
            //create the pages of the pagination
            var array_of_elements = [];
            var numP = 0;
            var nexP = show_per_page;
            //loop through all pages and assign elements into array
            for (i=1;i<=number_of_pages;i++)
            {    
                array_of_elements[i] = obj.children().slice(numP, nexP);
                numP += show_per_page;
                nexP += show_per_page;
            }
            
            // display first page and set first cookie
			/*if (options.cookies == true) {
				if (get_cookie("current")) {
					showPage(get_cookie("current"));
					createPagination(get_cookie("current"));
				} else {
					set_cookie( "current", "1");
					showPage(get_cookie("current"));
					createPagination(get_cookie("current"));
				}
			} else {
				showPage(1);
				createPagination(1);
			}*/
			showPage(intCurrentPage);
			createPagination(intCurrentPage);
            //show selected page
            function showPage(page) {
				if(page > 0){
					ajaxPage(page);
				   // obj.children().hide();
				   // array_of_elements[page].show();
				}
            }
            
            // create the navigation for the pagination 
            function createPagination(curr) {
				obj = jQuery("#page_navigation");
				var start, items = "", end, nav = "";
				if(number_of_pages > 1) {					
					//obj = jQuery("#page_navigation");
					//var start, items = "", end, nav = "";
					start = "<ul class='"+options.pagination_class+"'>";			
					var previous = "<li><a class='goto_previous' href='#'>"+options.previous+"</a></li>";				
					var next = "<li><a class='goto_next' href='#'>"+options.next+"</a></li>";
					var previous_inactive = "<li><a class='inactive'>"+options.previous+"</a></li>";
					var next_inactive = "<li><a class='inactive'>"+options.next+"</a></li>";
					end = "</ul>"
					var after = number_of_pages - options.after + 1;
					var pagi_range = paginationCalculator(curr);
					
					// the first page
					var fisrt_page = "<li><a href='#' class='goto' title='1' style='background-color:#FFF; color:#838D36; border:1px solid #838D36;'>1</a></li>";
					// the last page
					var last_page = "<li><a href='#' class='goto' title='" + number_of_pages + "' style='background-color:#FFF; color:#838D36; border:1px solid #838D36;'>" + number_of_pages + "</a></li>";
					
					// check value the first page or last page
					var isFirstPage = false;
					var isLastPage = false;
					
					// display pagination
					current_left = Math.ceil(curr) - 5;
					current_right = Math.ceil(curr) + 5;
					if(current_left > 0 && current_right <= number_of_pages) {					
						left = current_left;
						right = current_right;					
					} else if(current_left <= 0 && current_right <= number_of_pages && number_of_pages >= 11) {
						left = 1; 
						right = Math.ceil(left) + 10;
					} else if(current_left <= 0 && current_right <= number_of_pages && number_of_pages < 11) {
						left = 1; 
						right = number_of_pages;
					} else if(current_left > 0 && current_right > number_of_pages && number_of_pages >= 11) {
						left = Math.ceil(number_of_pages) - 10;
						right = number_of_pages;
					} else if((current_left > 0 && current_right > number_of_pages && number_of_pages < 11) || (current_left <= 0 && current_right > number_of_pages)) {
						left = 1;
						right = number_of_pages;
					} 			
					
					//for ( i = 1; i <= number_of_pages;i++)
					for ( i = left; i <= right;i++)
					{			
						if(i == 1) {
							isFirstPage = true;
						}
						if(i == number_of_pages) {
							isLastPage = true;
						}
						if (options.minimize == true) {
							var half = Math.ceil(number_of_pages/2);
							if (i >= pagi_range.start && i <= pagi_range.end) {
								if (i == curr) { items += '<li><a class="'+options.active+'" title="'+i+'">'+i+'</a></li>';} 
								else { items += '<li><a href="#" class="goto" title="'+i+'">'+i+'</a></li>';}
							} else if (curr <= half) {
								if (i >= (number_of_pages - 2)) {
									if (i == curr) { items += '<li><a class="'+options.active+'" title="'+i+'">'+i+'</a></li>';} 
									else { items += '<li><a href="#" class="goto" title="'+i+'">'+i+'</a></li>';}
								} 
							} else if (curr >= half) {
								if (i <= 2) {
									if (i == curr) { items += '<li><a class="'+options.active+'" title="'+i+'">'+i+'</a></li>';} 
									else { items += '<li><a href="#" class="goto" title="'+i+'">'+i+'</a></li>';}
								}
							}
						} else {
							if (i == curr) { items += '<li><a class="'+options.active+'" title="'+i+'">'+i+'</a></li>';} 
							else { items += '<li><a href="#" class="goto" title="'+i+'">'+i+'</a></li>';}
						}
					}	
					
					if (curr != 1 && curr != number_of_pages) {    
						// check first page and last page               
						if(isFirstPage == false && isLastPage == false) {
							 nav = start + fisrt_page + previous + items + next + last_page + end;
						} else if(isFirstPage == true && isLastPage == false) {
							 nav = start + previous + items + next + last_page + end;
						}  else if(isFirstPage == false && isLastPage == true) {
							 nav = start + fisrt_page + previous + items + next + end;
						} else {
							 nav = start + previous + items + next + end;
						}
					} else if (curr == 1 && number_of_pages == 1) {
						nav = start + previous_inactive + items + next_inactive + end;
					} else if (curr == number_of_pages){
						// check first page
						if(isFirstPage == true) {
							nav = start + previous + items + next_inactive + end;
						} else {
							nav = start + fisrt_page + previous + items + next_inactive + end;
						}
					}  else if (curr == 1) {
						// check last page
						if(isLastPage == true) {
							nav = start + previous_inactive + items + next + end;
						} else {
							nav = start + previous_inactive + items + next + last_page + end;
						}
					}				
					//obj.html(nav);
				}
				obj.html(nav);
            }
			
			/* code to handle cookies */
			/*function set_cookie( name, value ) {		  
			  $.cookie(name, value);
			}*/
			/*function get_cookie ( cookie_name )	{
			 	return $.cookie(cookie_name);
			}*/
            
			function paginationCalculator(curr)  {
				var half = Math.floor(options.nav_items/2);
				var upper_limit = number_of_pages - options.nav_items;
				var start = curr > half ? Math.max( Math.min(curr - half, upper_limit), 0 ) : 0;
				var end = curr > half?Math.min(curr + half + (options.nav_items % 2), number_of_pages):Math.min(options.nav_items, number_of_pages);
				return {start:start, end:end};
			}
			
            // handle click on pagination 
            jQuery(".goto").live("click", function(e){
                e.preventDefault();
                showPage(jQuery(this).attr("title"));
				//set_cookie( "current", $(this).attr("title"));
                jQuery(".pagination").remove();
                createPagination(jQuery(this).attr("title"));
            });
            jQuery(".goto_next").live("click", function(e) {
                e.preventDefault();
                var act = "."+options.active;
                var newcurr = parseInt(jQuery(".pagination").find(".active").attr("title")) + 1;
               // set_cookie( "current", newcurr);
				showPage(newcurr);
                jQuery(".pagination").remove();
                createPagination(newcurr);
            });
            jQuery(".goto_previous").live("click", function(e) {
                e.preventDefault();
                var act = "."+options.active;
                var newcurr = parseInt(jQuery(".pagination").find(".active").attr("title")) - 1;
				//set_cookie( "current", newcurr);
                showPage(newcurr);
                jQuery(".pagination").remove();
                createPagination(newcurr);
            });
        });
        
       
    };/*
	jQuery.cookie = function(name, value, options) {
		if (typeof value != 'undefined') { // name and value given, set cookie
			options = options || {};
			if (value === null) {
				value = '';
				options.expires = -1;
			}
			var expires = '';
			if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
				var date;
				if (typeof options.expires == 'number') {
					date = new Date();
					date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
				} else {
					date = options.expires;
				}
				expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
			}
			var path = options.path ? '; path=' + (options.path) : '';
			var domain = options.domain ? '; domain=' + (options.domain) : '';
			var secure = options.secure ? '; secure' : '';
			document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
		} else { // only name given, get cookie
			var cookieValue = null;
			if (document.cookie && document.cookie != '') {
				var cookies = document.cookie.split(';');
				for (var i = 0; i < cookies.length; i++) {
					var cookie = jQuery.trim(cookies[i]);
					// Does this cookie string begin with the name we want?
					if (cookie.substring(0, name.length + 1) == (name + '=')) {
						cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
						break;
					}
				}
			}
			return cookieValue;
		}
	};*/
})(jQuery);