/* 
jQuery Ajax Paginator
Author : Long
 
*/

/*

defaults.xString 
Allows you to pass extra params through the ajax query at anytime.
*/
function Paginator (url, options) {
	// Becomes this.options
	var defaults = {
		xParams : {},
		qString : 'category=&keyword=&page_custom=1',
		items:10,
		controls: 'iv_pager',
		content: 'pagination_content_wrapper',
		cache: false,
		duration: 800,
		timer: 500
	}
	
	this.options 	= jQuery.extend(defaults, options);
	
	this.init = function() {
		this.pControls = jQuery('.'+this.options.controls);
		this.pContent 	= jQuery('#'+this.options.content);
		this.newRequest = false;
		this.lastHash 	= thisLastHash;
		this.lastPage	= 1;
		if (this.options.cache) 
			this.cache 	= $empty;
		// Check Hash
		this.isHashed();
		// Set pagination click events 	
		if(this.pControls) 
			this.paginationEvents();
    };
	
	this.paginationEvents = function() { 
		var obj = this;
		jQuery('.category').click(function(e) { 
		});
		this.pControls.click(function(e) {	
			e.preventDefault();
			obj.loadPage(e.target);
		});
	};
	
	// Initial load check for a hash to load.
	this.isHashed = function() {	
		this.loadHash(this.stripHash());
		var obj = this;
		setInterval(function () { obj.hashPage(); }, this.options.timer);
	};
	
	// Periodical check for a new hash value to simulate back button ajax action
	this.hashPage = function() {
		var hash = this.stripHash();
		if(thisLastHash && thisLastHash!=hash) {
			this.loadHash(hash);	
		}
	};
	
	this.loadPage = function(el) {
		//var tmpURL = (typeof(el)=='object' ? el.href : el),
		dataArray = this.splitURL(el),
		//hash = dataArray[1];
		hash = el;
		
		thisLastHash = decodeURI(thisLastHash);
		hash = decodeURI(hash);
		
		if (thisLastHash && thisLastHash == hash) return;
		//if (this.newRequest) {
				this.newRequest = false;
				thisLastHash = window.location.hash = hash;
			
				this.getData(hash);
		//}
	};
	
	this.getData = function(hash) {
		objfrom = jQuery('[name=searchForm]');
		var $form = objfrom;
		var arrHash = hash.split('&');
		for (var i = arrHash.length - 1; i >= 0; i--){
			var arrHashItem = arrHash[i].split('=');
			Typeinput = 'input[name='+ arrHashItem[0] +']';
			if('category' == arrHashItem[0]) {
				Typeinput = 'select[name='+ arrHashItem[0] +']';
			}
	        $form.find(Typeinput).val(arrHashItem[1]);
		}
		
		var page_custom = $form.find( 'input[name="page_custom"]' ).val();
		ajaxRequest(page_custom,true,jQuery('[name=searchForm]'),true);
		var obj = this;
	};
	
	

	/* Loaders */
	
	// Load a page number 1,2,3 or next, prev, last, first
	this.pLoad = function (n) {
		this.loadPage(jQuery('#page_'+n).attr('href'));
	};
	// Load a page by full URL, if known
	this.hLoad = function (n) {
		//this.loadPage(this.pUrl + this.options.qString + n);
		this.newRequest = true;
		this.loadPage(this.options.qString);

	};
	// Load the current hashed page
	this.loadHash = function (hash) {
		if (hash)
			//this.loadPage(this.pUrl + '?' + hash);
			this.loadPage(hash);	
		else 
			this.hLoad();
	};
	
	/* Helpers */
	this.splitURL = function(o) {
		//alert(o);
		return o.split('?');
	};
	this.stripHash = function() {
		return window.location.hash.replace('#','');
	};
	this.convert = function(n) {
		return n*-1;
	};
	
    this.pUrl 		= url;
    this.init();
}


