/**#######################################################################
*
* Name          ：tab.js
*
* Comment       ：
*
* Copyright(c) 2009 C-UNIT SQUARE CO.,LTD. All Rights Reserved.
*
* Rev           Date            Editor          Comment
* 1.0.0         2009/04/30      A.Araki         新規作成
* ?             2010/01/25      A.Araki         tab.jsにタブ切り替え「タブが2つの場合」を追加
*
*#########################################################################
*/

var _doc = document;

/**----------------------------------------------------------------------
 * 表示、非表示を切り替える
 *
 * @param   string	id		切り替える箇所のID値
 * @return  none
 *
----------------------------------------------------------------------*/
// タブが2つの場合
function selectKind_tb2(id){
	selectKind_main(new Array('tab01box', 'tab02box'), id);
	selectKind_main(new Array('tab01', 'tab02'), id.substr(0, id.length - 3));
}

// タブが3つの場合
function selectKind(id){
	selectKind_main(new Array('tab01box', 'tab02box', 'tab03box'), id);
	selectKind_main(new Array('tab01', 'tab02', 'tab03'), id.substr(0, id.length - 3));
}

// タブが4つの場合
function selectKind02(id){
	selectKind_main(new Array('tab01box', 'tab02box', 'tab03box', 'tab04box'), id);
	selectKind_main(new Array('tab01', 'tab02', 'tab03', 'tab04'), id.substr(0, id.length - 3));
}

// 画像アップロードウィンドウ
function selectKind03(id){
	selectKind_main(new Array('up01box', 'up02box', 'up03box', 'up04box'), id);
	switch (id){
		
	case 'up01box': selectKind_main(new Array('up_tab01', 'up_tab02', 'up_tab03', 'up_tab05'), 'up_tab01'); break;
	case 'up02box': selectKind_main(new Array('up_tab01', 'up_tab02', 'up_tab03', 'up_tab05'), 'up_tab02'); break;
	case 'up03box': selectKind_main(new Array('up_tab01', 'up_tab02', 'up_tab03', 'up_tab05'), 'up_tab03'); break;
	case 'up04box': selectKind_main(new Array('up_tab01', 'up_tab02', 'up_tab03', 'up_tab05'), 'up_tab05'); break;
	}
}

function selectKind_main(id_list, sel_id) {
	var i, param;	
	for (i = 0; i < id_list.length; i ++) {
		obj = _doc.getElementById(id_list[i]);
		if (obj) {			
			if (id_list[i] == sel_id) {			
				param = 'block';				
			} else {
				param = 'none';
			}
			obj.style.display = param;			
		}
	}
}

/**----------------------------------------------------------------------
 * 画像の表示を切り替える
 *
 * @param   string	id		切り替える箇所のID値
 * @return  none
 *
----------------------------------------------------------------------*/

function chgImgImageSubmit(fileName,imgObj){
	imgObj.src = fileName;
}


/**----------------------------------------------------------------------
 * サイドメニューの表示を切り替える（プルダウン）
 *
 * @param   string	id		切り替える箇所のID値
 * @return  none
 *
----------------------------------------------------------------------*/

function showMenu(id){
		_doc.getElementById(id).style.display = 'block';
}

function hideMenu(id){
		_doc.getElementById(id).style.display = 'none';
}

/**----------------------------------------------------------------------
 * 選択したサブメニューの表示
 *
 * @param   string	vars	選択したサブメニューのパラメーター値
 * @return  none
 *
----------------------------------------------------------------------*/

window.onload = function selectSubMenu(){
		if(L_Search("edit") == "01"){
			selectKind('tab01box');
		}
		else if(L_Search("edit") == "02"){
			selectKind('tab02box');
		}
		else if(L_Search("edit") == "03"){
			selectKind('tab03box');
		}else {
			selectKind('tab01box');
		}


}

function L_Search(vars){
	if(location.search.length<2)return null;
	var LS_data = location.search.substr(1,location.search.length-1).split("&");
	var l = 0;
	for(;l<LS_data.length;l++){
		if(LS_data[l].indexOf("=")>-1)LS_data[l] = LS_data[l].split("=");
		else LS_data[l] = [LS_data[l],"default"];
	}
	for(l=0;l<LS_data.length;l++)if(LS_data[l][0]==vars)return LS_data[l][1];
	return null;
}

/**----------------------------------------------------------------------
 * トップページ　管理者メニューの表示、非表示を切り替える
 *
 * @param   string	id		切り替える箇所のID値
 * @return  none
 *
----------------------------------------------------------------------*/
function selectMenu(id){
	//クリックで開閉（複数表示可）
	obj=(_doc.all)?_doc.all(id):((_doc.getElementById)?_doc.getElementById(id):null);
	if(obj)	obj.style.display=(obj.style.display=="none")?"block":"none";
}

/**----------------------------------------------------------------------
 * tab in facebook
 *
 * @param   string	id		切り替える箇所のID値
 * @return  none
 *
----------------------------------------------------------------------*/
function selectFBTab(id){
	selectKind_main(new Array('fb_up01box', 'fb_up02box', 'fb_up03box'), id);

	switch (id){
		case 'fb_up01box': selectKind_main(new Array('up_fb_tab01', 'up_fb_tab02', 'up_fb_tab03'), 'up_fb_tab01'); break;
		case 'fb_up02box': selectKind_main(new Array('up_fb_tab01', 'up_fb_tab02', 'up_fb_tab03'), 'up_fb_tab02'); break;
		case 'fb_up03box': selectKind_main(new Array('up_fb_tab01', 'up_fb_tab02', 'up_fb_tab03'), 'up_fb_tab03'); break;
	}
}

/**----------------------------------------------------------------------
 * open detail of tab in facebook
 *
 * @param   string	id		切り替える箇所のID値
 * @return  none
 *
----------------------------------------------------------------------*/
function openFBdetail(tabId, detailId){
	selectFBTab(tabId);
	if(detailId != null || detailId != undefined)
	{
		switch (tabId){
			case 'fb_up01box': selectKind_main(new Array('fb_up01box_01', 'fb_up01box_02'), detailId); break;
			case 'fb_up02box': selectKind_main(new Array('fb_up02box_01', 'fb_up02box_02'), detailId); break;
		}
	}
}

/**----------------------------------------------------------------------
 * Select tab in twitter
 *
 * @param   string	id		切り替える箇所のID値
 * @return  none
 *
----------------------------------------------------------------------*/
function selectTWTab(id){
	selectKind_main(new Array('tw_up01box', 'tw_up02box'), id);
	switch (id){
			case 'tw_up01box': selectKind_main(new Array('up_tw_tab01', 'up_tw_tab02'), 'up_tw_tab01'); break;
			case 'tw_up02box': selectKind_main(new Array('up_tw_tab01', 'up_tw_tab02'), 'up_tw_tab02'); break;
		}
}

/**----------------------------------------------------------------------
 * Open detail of tab in twitter
 *
 * @param   string	id		切り替える箇所のID値
 * @return  none
 *
----------------------------------------------------------------------*/
function openTWdetail(tabId, detailId) {
	// Save the the current tab id
	cur_tab_id = tabId;

	selectTWTab(tabId);
	if(detailId != null || detailId != undefined)
	{
		switch (tabId){
			case 'tw_up01box':
				selectKind_main(new Array('tw_up01box_01', 'tw_up01box_02'), detailId);
				curr_detail01_id = detailId;
				break;
			case 'tw_up02box':
				selectKind_main(new Array('tw_up02box_01', 'tw_up02box_02'), detailId);
				curr_detail02_id = detailId;
				break;
		}
	}
}
