njRecord = function() {
	/**
	 * レコード格納変数
	 * @var object
	 */
	this.db = {}

	/**
	 * レコード読み込み
	 * @param  string   url      レコードを JSON 形式で返してくれる URL
	 * @param  function callback 読み込み完了時に呼び出すコールバック関数
	 * @return object            レコード
	 */
	this.get = function(url, callback) {
		if (!this.db[url] && 'undefined' != typeof(url)) {
			this.db[url] = null;

			jQuery.ajax({
				async:false,
				url:url,
				success:function(msg, textStatus) {
					eval('nj.record.db[url] = ' + msg + ';');

					if (callback) {
						callback(nj.record.db[url]);
					}
				}
			});
		} else {
			if (callback) {
				callback(this.db[url]);
			}
		}

		return this.db[url];
	}

	/**
	 * レコード処理要求
	 * @param string   url      レコードを処理してくれる URL
	 * @param object   param    渡すオブジェクト
	 * @param function callback 処理完了時に呼び出すコールバック関数
	 */
	this.request = function(url, param, callback) {
		jQuery.ajax({
			url:url,
			type:'post',
			data:param,
			success:function(msg, textStatus) {
				if (callback) {
					callback(msg, textStatus);
				}
			}
		});
	}

	/**
	 * レコードキャッシュ削除
	 * @param string url 削除するレコードのURL
	 */
	this.clear = function(url) {
		this.db[url] = null;
	}
}
