/**
 * njプラグインリスト
 * @var object
 */
var nj_plugin_list = {
	table  : '',
	panel  : '',
	select : '',
	flash  : ''
};

/**
 * njスクリプト開始
 * @var string
 */
var nj_script_left  = '(';

/**
 * njスクリプト終了
 * @var string
 */
var nj_script_right = ')';



/**
 * njスクリプト初期化
 */
nj.init = function(path_public) {
	var js_list = [
		'njScript/njRecord.js'
	];

	var i, key;

	// プラグイン追加
	for (key in nj_plugin_list) {
		js_list.push('njScript/plugin/' + key + '.js');
	}

	// 外部ファイル読み込み
	for (i = 0; i < js_list.length; i ++) {
		document.write('<script type="text/javascript" src="' + path_public + 'js/' + js_list[i] + '"></script>');
	}
}

/**
 * njオブジェクト取得
 * 同じIDを持つnjオブジェクトがいる場合、最後に見つかったnjオブジェクトを返す。
 * 
 * @param  string id 取得するnjオブジェクトのID
 * @return object    njオブジェクト
 */
function nj(id) {
	var obj, key;
	for (key in nj_plugin_list) {
		// njプラグインを利用しているDOMを列挙
		//jQuery('[class*=nj-' + key + '(]').each(function() {
		jQuery('.nj-' + key + '-show').each(function() {
			// njオブジェクトIDを持つものを検索
			if (id == jQuery(this).data('id')) {
				// 見つけたので格納
				obj = jQuery(this).data('nj');
			}
		});
	}
	return obj;
}

/**
 * njオブジェクト割り当て
 */
nj.create = function() {
	var key, function_name;
	var class_search;
	var plugin, script;
	var args;

	for (key in nj_plugin_list) {
		//class_search = '[class*=nj-' + key + '(]';
		class_search = '.nj-' + key + '-show';
		jQuery(class_search).each(function() {
			// 既に ID が付いていたら作成済みと判断
			if ('undefined' != typeof(jQuery(this).data('id'))) {
				jQuery(this).attr('class');
				return;
			}

			function_name = 'nj_create_' + key;
			if ('undefined' != eval('typeof(' + function_name + ')')) {
				args = new Object();
				{
					plugin = 'nj-' + key;
					script = jQuery(this).attr('class');
					if ('' != script) {
						var strPluginFirst    = plugin + nj_script_left;
						var intPluginFirstPos = script.indexOf(strPluginFirst);
						var strScript         = script.substr(intPluginFirstPos, script.length - intPluginFirstPos);
						var line              = strScript.substr(strPluginFirst.length, strScript.indexOf(nj_script_right) - strPluginFirst.length);
						var params            = line.split('&');

						for (i = 0; i < params.length; i ++) {
							key_val = params[i].split('=');
							args[key_val[0]] = key_val[1];
							if (!isNaN(key_val[1] + 0)) {
								args[key_val[0]] = Number(key_val[1]);
							}
						}
					}
				}

				if ('undefined' != typeof(args.id)) {
					jQuery(this).data('id', args.id);
				}

				eval(function_name + '(jQuery(this), args)');
			}
		});
	}
}

/**
 * njオブジェクト作成
 */
nj.create_object = function(obj_top, obj_nj) {
	obj_nj.jq = obj_top;

	// 属性処理メソッド定義
	obj_nj.attr = function(key, val) {
		// 設定
		if ('undefined' != typeof(val)) {
			this.args[key] = val;
			// 自分を返す
			return this;
		}
		// 取得
		else {
			var result = this.args[key];
			// 値を返す
			return result;
		}
	}

	// トップの jQuery オブジェクトにnjオブジェクトを挿入
	obj_top.data('nj', obj_nj);

	return obj_nj;
}

/**
 * njオブジェクト位置指定スクリプト展開
 * @param object target 基準とする jQuery オブジェクト
 * @param mixed  pos    位置指定スクリプト
 * @param string dir    操作方向(x=横位置,y=縦位置)
 */
nj.position = function(target, pos, dir) {
	if (!isNaN(pos + 0)) {
		return Number(pos);
	}

	// 画面サイズ
	var screen_size;
	switch (dir) {
	case 'x': screen_size = jQuery(window).width();  break;
	case 'y': screen_size = jQuery(window).height(); break;
	}

	// スクロール位置
	var scroll_pos;
	switch (dir) {
	case 'x': scroll_pos = jQuery(window).scrollLeft(); break;
	case 'y': scroll_pos = jQuery(window).scrollTop();  break;
	}

	// njオブジェクトサイズ
	var target_size;
	switch (dir) {
	case 'x': target_size = target.width();  break;
	case 'y': target_size = target.height(); break;
	}

	var i;

	var param = pos.split(',');
	pos = 0;
	for (i = 0; i < param.length; i ++) {
		switch (param[i]) {
		// 最小側
		case 'min':
			pos = 0;
			break;
		// 最大側
		case 'max':
			pos = screen_size - target_size;
			break;
		// 中央設定
		case 'center':
			pos = Math.floor((screen_size - target_size) / 2);
			break;
		// スクロール位置設定
		case 'scroll':
			pos = scroll_pos;
			break;
		// その他
		default:
			// 数値か？
			if (!isNaN(param[i] + 0)) {
				// 数値分移動
				pos += Number(param[i]);
			}
			break;
		}
	}

	return pos;
}

/**
 * Hide all TinyMCE editor in current layer before showing a new flash layer
 *	(for fixed layer overlap in Chrome Browser)
 */
function hideTinyMceEditor() {
	// We only hide all TinyMCE editor in Chrome browser
	jQuery.each(jQuery.browser, function(i, val) {
      if (i == 'safari' && val == true)	{
		jQuery('table.mceLayout tr td.mceIframeContainer').hide();
	  }
    });
}

/**
 * デバッグ表示
 */
function trace(obj, prefix, suffix) {
	var i, key;
	var result;

	if ('undefined' == typeof(prefix)) {
		prefix = '';
	}
	if ('undefined' == typeof(suffix)) {
		suffix = '';
	}

	switch (typeof(obj)) {
	case 'object':
		for (key in obj) {
			if (!trace(obj[key], prefix + key + '=', suffix)) {
				break;
			}
		}
		break;
	case 'array':
		for (i = 0; i < obj.length; i ++) {
			if (!trace(obj[i], prefix + i + '=', suffix)) {
				break;
			}
		}
		break;
	default:
		result = confirm(prefix + obj + suffix);
		break;
	}

	return result;
}



// 初期化
jQuery(function() {
	nj.record = new njRecord();
	nj.create();
});
