/**
 * njパネル作成
 * @param object obj_top 作成対象のjQueryオブジェクト
 * @param object args    作成時に渡された引数
 */
function nj_create_panel(obj_top, args) {
	// パネルを作成
	var obj_panel = jQuery('<div></div>')
		.appendTo('body')
		.addClass('nj-panel-root')
		.hide()
	;

	var strBgColor = '#000000';
	var opacity = 0.5
	// Setting the new mask background color
	if ('undefined' != typeof(args.mask_background)) {		
		strBgColor = args.mask_background;
		if(strBgColor == 'transparent'){
			opacity = 0.1
		}
	}	
	
	// マスクを作成、パネルに乗せる
	var obj_mask = jQuery('<div></div>')
		.addClass('nj-panel-mask')
		.css({
			position:'fixed',
			backgroundColor:strBgColor,
			opacity:opacity,
			filter:'alpha(opacity=10)',
			top:0,
			left:0,
			width:'100%',
			height:'100%'
		})
		.appendTo(obj_panel)
	;

	var obj_top_draggable_option = {};
	
	// Setting the ignorance for drag region
	if ('undefined' != typeof(args.ignore_drag)) {
		// Fix cannot select Google Map type on IE9
		/*C-UNIT 2011/12/06
		 * #5855
		 * fix IE9
		 */
		//if(navigator.userAgent.indexOf("Trident/5")<=-1){
			obj_top_draggable_option = {cancel: args.ignore_drag};
		//}

	}
	
//---- > IE6
	if (0 <= navigator.userAgent.indexOf("MSIE 6")) {
		jQuery('select').css('zIndex', 1);

		jQuery('<iframe src="#"></iframe>')
			.prependTo(obj_mask)
			.addClass('nj-panel-mask')
			.css({
				filter:'alpha(opacity=0)',
				zIndex:100
			})
		;

		obj_mask.css('position', 'absolute');
		jQuery(".nj-panel-mask").css('top',    jQuery(document).scrollTop());
		jQuery(".nj-panel-mask").css('left',   jQuery(document).scrollLeft());
		jQuery(".nj-panel-mask").css('width',  jQuery(window).width()  + 'px');
		jQuery(".nj-panel-mask").css('height', jQuery(window).height() + 'px');
	}
//< ---- IE6

	// 対象をパネルに乗せる
	obj_top
		.appendTo(obj_panel)
		.draggable(obj_top_draggable_option)
	;

	var option = {
		args : args,
		obj_root : obj_panel,
		obj_mask : obj_mask,
		obj_body : obj_top,
		bOpen    : false,
		open : function(option) {
			this.obj_root.show();
			this.obj_body.show();
			this.bOpen = true;

			if ('undefined' == typeof(option)) {
				option = {}
			}

			if ('undefined' != typeof(option.use_mask) && 0 == option.use_mask) {
				this.obj_mask.hide();
			} else {
				this.obj_mask.show();
			}

			var key;
			for (key in option) {
				this.args[key] = option[key];
			}

			if ('undefined' != typeof(args.x)) { this.setX(args.x); }
			if ('undefined' != typeof(args.y)) { this.setY(args.y); }
		},
		close : function() {
			this.obj_root.hide();
			this.bOpen = false;
		},
		setPos : function(x, y) {
			this.setX(x);
			this.setY(y);
		},
		setX : function(x) {
			this.obj_body.css({position:'absolute', left:nj.position(this.obj_body, x, 'x')});
		},
		setY : function(y) {
			this.obj_body.css({position:'absolute', top :nj.position(this.obj_body, y, 'y')});
		},
		isOpen : function() {
			return this.bOpen;
		}
	}

	// njオブジェクト作成
	nj.create_object(obj_top, option);
}
