/**
 * 監視オブジェクト割り当て
 * @param object obj_top 作成対象のjQueryオブジェクト
 * @param object args    作成時に渡された引数
 */
function nj_create_watch(obj_top, args) {
	if (null == args.interval) {
		args.interval = 1000;
	}

	var option = {
		css : args.css
	}

	// njオブジェクトとして登録
	var obj = nj.create_object(obj_top, option);

	// チェック情報作成
	var key, check_key;
	var check;
	for (key in args) {
		if (-1 == key.indexOf('css_')) {
			continue;
		}
		check_key = key.replace('css_', '');
		check[check_key] = args[key];
	}

	// 監視オブジェクト作成
	nj.watch.create({
		id       : args.id,
		target   : args.target,
		check    : check,
		interval : args.interval,
		match    : function(data) {
			if ('undefined' != typeof(data.args)) {
				data.jq.removeClass(data.args.css);
			}
		},
		unmatch  : function(data) {
			if ('undefined' != typeof(data.args)) {
				data.jq.addClass(data.args.css);
			}
		},
		data     : obj
	});
}
